﻿Public Class frm_Main
    Dim AktuelleAktionChecked As Object
    Dim AktuelleAktion As String
    Dim nStartPos As Point
    Dim nDragPos As Point
    Private Sub frm_Main_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    End Sub
    
    Private Sub GenerellesMouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        If e.Button = Windows.Forms.MouseButtons.Left Then
            Dim nCurPos As Point = sender.PointToScreen(New Point(e.X, e.Y))
            Dim nNewPos As New Point(nStartPos.X + nCurPos.X - nDragPos.X, _
              nStartPos.Y + nCurPos.Y - nDragPos.Y)
            With nNewPos
                If .X < Me.ClientRectangle.Left Then .X = Me.ClientRectangle.Left
                If .X + sender.Width > Me.ClientRectangle.Right Then
                    .X = Me.ClientRectangle.Right - sender.Width
                End If
                If .Y < Me.ClientRectangle.Top Then .Y = Me.ClientRectangle.Top
                If .Y + sender.Height > Me.ClientRectangle.Bottom Then
                    .Y = Me.ClientRectangle.Bottom - sender.Height
                End If
            End With
            sender.Location = nNewPos
        End If
    End Sub


    Private Sub GenerellesMousedown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel.MouseDown
        Dim AktuelleMousePosition As New Point
        AktuelleMousePosition.X = Panel.MousePosition.X
        AktuelleMousePosition.Y = Panel.MousePosition.Y - 45

        If e.Button = Windows.Forms.MouseButtons.Left Then
            Select Case AktuelleAktion
                Case UNDToolStripMenuItem.ToString
                    PaintUndBox(AktuelleMousePosition)
                Case ODERToolStripMenuItem.ToString
                    PaintOderBox(AktuelleMousePosition)
                Case LöschenToolStripMenuItem.ToString
                    LöscheBox(sender)
                Case VerschiebenToolStripMenuItem.ToString
                    VerschiebeBlock(sender)
                Case NamenErmittelnToolStripMenuItem.ToString
                    ErmittleNamen(sender)
                Case Else
            End Select
        End If

        If e.Button = Windows.Forms.MouseButtons.Right Then
            AktuelleAktionChecked.checked = False
            AktuelleAktion = Nothing
            StatusAktuelleAktion.Text = " Keine Aktion aktiv "
        End If

    End Sub

    Sub PaintUndBox(ByVal Location As Point)
        Dim a As New Panel
        Dim ns As New Size
        ns.Width = 40
        ns.Height = 65
        With a
            .ForeColor = Color.Red
            .BackColor = Color.Red
            .Location = Location
            .Size = ns
        End With
        a.Name = "UND_" & Panel.Controls.Count
        Panel.Controls.Add(a)
        AddHandler a.MouseDown, AddressOf GenerellesMousedown
        AddHandler a.MouseMove, AddressOf GenerellesMouseMove
    End Sub
    Sub PaintOderBox(ByVal Location As Point)
        Dim a As New Panel
        Dim ns As New Size
        ns.Width = 40
        ns.Height = 65
        With a
            .ForeColor = Color.Blue
            .BackColor = Color.Blue
            .Location = Location
            .Size = ns
        End With
        a.Name = "ODER_" & Panel.Controls.Count
        Panel.Controls.Add(a)
        AddHandler a.MouseDown, AddressOf GenerellesMousedown
        AddHandler a.MouseMove, AddressOf GenerellesMouseMove
    End Sub

    Sub LöscheLetzteAktion()
        On Error Resume Next
        If AktuelleAktionChecked <> Nothing Then
            AktuelleAktionChecked.checked = False
            AktuelleAktion = Nothing
        End If
    End Sub

    Sub VerschiebeBlock(ByVal Objekt As Object)
        nStartPos = New Point(0, -45)
    End Sub

    Sub ErmittleNamen(ByVal WelcherBlock As Object)
        MsgBox(DirectCast(WelcherBlock, Control).Name, MsgBoxStyle.OkOnly, "Der Name des Blockes ist:")
    End Sub
    Sub LöscheBox(ByVal Referenz As Object)
        Dim Controlname As String
        If Panel.Controls.Count = 0 Then
            Exit Sub
        End If
        Controlname = DirectCast(Referenz, Control).Name()
        For i = 0 To Panel.Controls.Count - 1
            If Panel.Controls.Item(i).Name = Controlname Then
                Panel.Controls.RemoveAt(i)
                Exit For
            End If
        Next
    End Sub







    Private Sub UNDToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UNDToolStripMenuItem.Click
        LöscheLetzteAktion()
        StatusAktuelleAktion.Text = " UND Block erstellen "
        AktuelleAktionChecked = UNDToolStripMenuItem
        AktuelleAktion = UNDToolStripMenuItem.ToString
    End Sub

    Private Sub LöschenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LöschenToolStripMenuItem.Click
        LöscheLetzteAktion()
        StatusAktuelleAktion.Text = " Block löschen "
        AktuelleAktionChecked = LöschenToolStripMenuItem
        AktuelleAktion = LöschenToolStripMenuItem.ToString
    End Sub

    Private Sub NamenErmittelnToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NamenErmittelnToolStripMenuItem.Click
        LöscheLetzteAktion()
        StatusAktuelleAktion.Text = " Blocknamen ermitteln "
        AktuelleAktionChecked = NamenErmittelnToolStripMenuItem
        AktuelleAktion = NamenErmittelnToolStripMenuItem.ToString
    End Sub

    Private Sub ODERToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ODERToolStripMenuItem.Click
        LöscheLetzteAktion()
        StatusAktuelleAktion.Text = " ODER Block erstellen "
        AktuelleAktionChecked = ODERToolStripMenuItem
        AktuelleAktion = ODERToolStripMenuItem.ToString
    End Sub

    Private Sub VerschiebenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VerschiebenToolStripMenuItem.Click
        LöscheLetzteAktion()
        StatusAktuelleAktion.Text = " Block verschieben "
        AktuelleAktionChecked = VerschiebenToolStripMenuItem
        AktuelleAktion = VerschiebenToolStripMenuItem.ToString
    End Sub
    Private Sub BeendenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BeendenToolStripMenuItem.Click
        End
    End Sub

    Private Sub Wächter_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Wächter.Tick
        If Panel.Controls.Count > 0 Then
            LöschenToolStripMenuItem.Enabled = True
            VerschiebenToolStripMenuItem.Enabled = True
            NamenErmittelnToolStripMenuItem.Enabled = True
        Else
            LöschenToolStripMenuItem.Enabled = False
            VerschiebenToolStripMenuItem.Enabled = False
            NamenErmittelnToolStripMenuItem.Enabled = False
        End If
    End Sub
End Class
